#!/bin/sh
#
# gather some data from some public NetAtmo weather stations...
#

# login data: keep private!!
C_ID=eineID
C_SECRET=einSecret
C_USER="einUser"
C_PW="einPasswort"

# where to store the access- and refresh-token...
ATOKEN="/tmp/netatmo.atoken"
RTOKEN="/tmp/netatmo.rtoken"

# the output from curl...
JSON_STRING=""

# check the access-token file: does not exist...
if test ! -e "$ATOKEN"
then
	# login and parse access-token...
	JSON_STRING=`curl -s -d "grant_type=password&client_id=$C_ID&client_secret=$C_SECRET&username=$C_USER&password=$C_PW&scope=read_station read_thermostat" "https://api.netatmo.net/oauth2/token"`
	echo $JSON_STRING | awk -F\" '{print $4}' > $ATOKEN
	echo $JSON_STRING | awk -F\" '{print $8}' > $RTOKEN
fi

# ...is older than 3:00...
if test `find $ATOKEN -mmin +180`
then
	JSON_STRING=`curl -s -d "grant_type=password&client_id=$C_ID&client_secret=$C_SECRET&username=$C_USER&password=$C_PW&scope=read_station read_thermostat" "https://api.netatmo.net/oauth2/token"`
	echo $JSON_STRING | awk -F\" '{print $4}' > $ATOKEN
	echo $JSON_STRING | awk -F\" '{print $8}' > $RTOKEN
# older then 2:00...
elif test `find $ATOKEN -mmin +120`
then
	# refresh the token...
	RT=`cat $RTOKEN`
	JSON_STRING=`curl -s -d "grant_type=refresh_token&client_id=$C_ID&client_secret=$C_SECRET&refresh_token=$RT" "https://api.netatmo.net/oauth2/token"`
	echo $JSON_STRING | awk -F\" '{print $4}' > $ATOKEN
	echo $JSON_STRING | awk -F\" '{print $8}' > $RTOKEN
fi

# we have a valid access token, now get the data...
AT=`cat $ATOKEN`
JSON_STRING=`curl -s -d "access_token=$AT&device_id=aa:bb:cc:dd:ee:ff&type=pressure&scale=30min&date_end=last" "https://api.netatmo.net/api/getmeasure"`
VAL=`echo $JSON_STRING | awk -F'[^0-9.]*' '{print $3}'`
curl -s --header "Content-Type: text/plain" --request PUT --data "$VAL" "http://hometest:8080/rest/items/Netatmo_pressure/state"

JSON_STRING=`curl -s -d "access_token=$AT&device_id=aa:bb:cc:dd:ee:ff&module_id=02:00:cc:dd:ee:ff&type=temperature,humidity&scale=30min&date_end=last" "https://api.netatmo.net/api/getmeasure"`
VAL=`echo $JSON_STRING | awk -F'[^0-9.]*' '{print $3}'`
curl -s --header "Content-Type: text/plain" --request PUT --data "$VAL" "http://hometest:8080/rest/items/Netatmo_temperature/state"
VAL=`echo $JSON_STRING | awk -F'[^0-9.]*' '{print $4}'`
curl -s --header "Content-Type: text/plain" --request PUT --data "$VAL" "http://hometest:8080/rest/items/Netatmo_humidity/state"

JSON_STRING=`curl -s -d "access_token=$AT&device_id=aa:bb:cc:dd:ee:ff&module_id=05:00:cc:dd:ee:ff&type=rain&scale=30min&date_end=last" "https://api.netatmo.net/api/getmeasure"`
VAL=`echo $JSON_STRING | awk -F'[^0-9.]*' '{print $3}'`
curl -s --header "Content-Type: text/plain" --request PUT --data "$VAL" "http://hometest:8080/rest/items/Netatmo_rain/state"

# that's all, run in crontab every 10 minutes...
